<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__profile__functions__counter" kind="group">
    <compoundname>group_profile_functions_counter</compoundname>
    <title>Counter Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1gaa727295348b428f46dc3d0a7e1f1681f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_Profile_ClearConfiguration</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_Profile_ClearConfiguration</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Clears all counter configurations and sets all counters and overflow counters to 0. </para>        </briefdescription>
        <detaileddescription>
<para>Calls <ref kindref="member" refid="group__group__profile__functions__counter_1ga254eeff2dec6c28e1819373ed6106c7c">Cy_Profile_ClearCounters()</ref> to clear counter registers.</para><para><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />A<sp />new<sp />profiling<sp />session<sp />with<sp />a<sp />different<sp />set<sp />of<sp />counter</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />configurations<sp />need<sp />to<sp />be<sp />allocated.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />cntIdx;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disable<sp />all<sp />the<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(cntIdx<sp />=<sp />0u;<sp />cntIdx<sp />&lt;<sp />PROFILE_PRFL_CNT_NR;<sp />cntIdx++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga7b44ab102e66cd5a0b243ac67dbd1c3c">Cy_Profile_DisableCounter</ref>(cntHandle[cntIdx]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />all<sp />counter<sp />configurations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__counter_1gaa727295348b428f46dc3d0a7e1f1681f">Cy_Profile_ClearConfiguration</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="165" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="161" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="476" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1ga254eeff2dec6c28e1819373ed6106c7c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE void</type>
        <definition>__STATIC_INLINE void Cy_Profile_ClearCounters</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_Profile_ClearCounters</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Clears all hardware counters to 0. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />A<sp />new<sp />profiling<sp />window<sp />needs<sp />to<sp />be<sp />started<sp />with<sp />the<sp />counter</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />values<sp />reset<sp />to<sp />0.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stop<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1ga4a4a1151a6c68338ab316b8119ae91ec">Cy_Profile_StopProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />all<sp />counters<sp />before<sp />starting<sp />a<sp />new<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga254eeff2dec6c28e1819373ed6106c7c">Cy_Profile_ClearCounters</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />applicable,<sp />clear<sp />the<sp />overflow<sp />bits<sp />in<sp />the<sp />data<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1gad8b4c8660845665052ffc891d9b1cd50">Cy_Profile_StartProfiling</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="499" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" bodystart="496" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="477" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
        <definition>cy_stc_profile_ctr_ptr_t Cy_Profile_ConfigureCounter</definition>
        <argsstring>(en_ep_mon_sel_t monitor, cy_en_profile_duration_t duration, cy_en_profile_ref_clk_t refClk, uint32_t weight)</argsstring>
        <name>Cy_Profile_ConfigureCounter</name>
        <param>
          <type>en_ep_mon_sel_t</type>
          <declname>monitor</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__profile__enums_1ga82efb19440328ed10ceb3ae66ac4e6f3">cy_en_profile_duration_t</ref></type>
          <declname>duration</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__profile__enums_1gaf4167388440a79a2671d7c1bea86785c">cy_en_profile_ref_clk_t</ref></type>
          <declname>refClk</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>weight</declname>
        </param>
        <briefdescription>
<para>Configures and assigns a hardware profile counter to the list of used counters. </para>        </briefdescription>
        <detaileddescription>
<para>This function assigns an available profile counter to a slot in the internal software data structure and returns the handle for that slot location. The data structure is used to keep track of the counter status and to implement a 64-bit profile counter. If no counter slots are available, the function returns a NULL pointer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>monitor</parametername>
</parameternamelist>
<parameterdescription>
<para>The monitor source number</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>duration</parametername>
</parameternamelist>
<parameterdescription>
<para>Events are monitored (0), or duration is monitored (1)</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>refClk</parametername>
</parameternamelist>
<parameterdescription>
<para>Counter reference clock</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>weight</parametername>
</parameternamelist>
<parameterdescription>
<para>Weighting factor for the counter value</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>A pointer to the counter data structure. NULL if no counter is available.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />SCB0<sp />bus<sp />transfers<sp />need<sp />to<sp />be<sp />monitored<sp />during<sp />a<sp />fixed<sp />window.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />The<sp />profile<sp />interrupt<sp />is<sp />configured<sp />using<sp />the<sp />sysint<sp />driver.<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />It's<sp />handler<sp />function<sp />is<sp />Cy_Profile_ISR().<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />energy<sp />profiler<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__general_1ga3a4f9cb2191f4c950821aca1c56766b2">Cy_Profile_Init</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__functions__counter_1gaa727295348b428f46dc3d0a7e1f1681f">Cy_Profile_ClearConfiguration</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />a<sp />profile<sp />counter<sp />to<sp />monitor<sp />the<sp />SCB0<sp />bus<sp />transfer<sp />events<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cntHandle[0]<sp />=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter</ref>(SCB0_MONITOR_AHB,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SCB0<sp />bus<sp />transfer<sp />count<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1gga82efb19440328ed10ceb3ae66ac4e6f3a4164d3e39093109cb37d74adac47c6c3">CY_PROFILE_EVENT</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Count<sp />number<sp />of<sp />SCB0<sp />bus<sp />transfers<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1ggaf4167388440a79a2671d7c1bea86785cab734f4cdfa75f56ad1bbecdfd22dc137">CY_PROFILE_CLK_TIMER</ref>,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ignored<sp />for<sp />"event"<sp />counting<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />20000UL);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Weight<sp />of<sp />20000<sp />(example)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(cntHandle[0]<sp />==<sp />NULL)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cannot<sp />allocate<sp />this<sp />counter.<sp />Check<sp />and<sp />try<sp />again.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />assigned<sp />counter<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__profile__functions__counter_1gadb0af4c3dfab0094b3c37192f600f351">Cy_Profile_EnableCounter</ref>(cntHandle[0]);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="228" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="195" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="478" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1ga76efcb49377e1bbeffd2eab29d8673ca" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__enums_1ga7d980aa8f4c0159ccc47a973dd543e02">cy_en_profile_status_t</ref></type>
        <definition>cy_en_profile_status_t Cy_Profile_FreeCounter</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ctrAddr)</argsstring>
        <name>Cy_Profile_FreeCounter</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ctrAddr</declname>
        </param>
        <briefdescription>
<para>Frees up a counter from a previously-assigned monitor source. </para>        </briefdescription>
        <detaileddescription>
<para><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref> must have been called for this counter before calling this function.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ctrAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>The handle to the assigned counter (returned by calling <ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref>).</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation.</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The counter is not disabled by this function.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />A<sp />profile<sp />counter<sp />in<sp />position<sp />#0<sp />was<sp />previously<sp />in<sp />use.<sp />It<sp />needs</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />to<sp />be<sp />reconfigured<sp />to<sp />monitor<sp />the<sp />CM0+<sp />active<sp />cycles<sp />count.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Free<sp />the<sp />profile<sp />counter<sp />in<sp />position<sp />#0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga76efcb49377e1bbeffd2eab29d8673ca">Cy_Profile_FreeCounter</ref>(cntHandle[0]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />a<sp />profile<sp />counter<sp />to<sp />monitor<sp />the<sp />CM0+<sp />active<sp />cycle<sp />count<sp />events<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cntHandle[0]<sp />=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter</ref>(CPUSS_MONITOR_CM0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />active<sp />cycle<sp />count<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1gga82efb19440328ed10ceb3ae66ac4e6f3a4164d3e39093109cb37d74adac47c6c3">CY_PROFILE_EVENT</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Count<sp />number<sp />of<sp />CM0+<sp />active<sp />cycles<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1ggaf4167388440a79a2671d7c1bea86785cab734f4cdfa75f56ad1bbecdfd22dc137">CY_PROFILE_CLK_TIMER</ref>,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ignored<sp />for<sp />"event"<sp />counting<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />40000UL);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Weight<sp />of<sp />40000<sp />(example)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="262" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="252" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="479" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1gadb0af4c3dfab0094b3c37192f600f351" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__enums_1ga7d980aa8f4c0159ccc47a973dd543e02">cy_en_profile_status_t</ref></type>
        <definition>cy_en_profile_status_t Cy_Profile_EnableCounter</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ctrAddr)</argsstring>
        <name>Cy_Profile_EnableCounter</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ctrAddr</declname>
        </param>
        <briefdescription>
<para>Enables an assigned counter. </para>        </briefdescription>
        <detaileddescription>
<para><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref> must have been called for this counter before calling this function.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ctrAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>The handle to the assigned counter, (returned by calling <ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref>).</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />A<sp />profile<sp />counter<sp />needs<sp />to<sp />be<sp />configured<sp />and<sp />enabled<sp />to<sp />count</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />the<sp />number<sp />of<sp />HFCLK0<sp />cycles<sp />in<sp />the<sp />profiling<sp />window.<sp />The<sp />energy<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />profiler<sp />is<sp />initialized<sp />and<sp />the<sp />profile<sp />interrupt<sp />is<sp />configured</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />and<sp />enabled.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />a<sp />profile<sp />counter<sp />to<sp />count<sp />the<sp />number<sp />of<sp />HFCLK0<sp />cycles<sp />in<sp />the<sp />profiling<sp />window<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cntHandle[0]<sp />=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter</ref>(PROFILE_ONE,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Constant<sp />1<sp />(always<sp />count)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1gga82efb19440328ed10ceb3ae66ac4e6f3a175867d1f00ea74e17f4290d7bdf468d">CY_PROFILE_DURATION</ref>,</highlight><highlight class="comment">/*<sp />Count<sp />number<sp />of<sp />clock<sp />cycles<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__profile__enums_1ggaf4167388440a79a2671d7c1bea86785ca1e37f3a78d1d64e950d826d26793cb98">CY_PROFILE_CLK_HF</ref>,<sp /><sp /></highlight><highlight class="comment">/*<sp />HFCLK0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1UL);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Normalization<sp />weight<sp />of<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1gadb0af4c3dfab0094b3c37192f600f351">Cy_Profile_EnableCounter</ref>(cntHandle[0]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />the<sp />profiling<sp />window<sp />when<sp />ready.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="297" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="284" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="480" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__profile__functions__counter_1ga7b44ab102e66cd5a0b243ac67dbd1c3c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__profile__enums_1ga7d980aa8f4c0159ccc47a973dd543e02">cy_en_profile_status_t</ref></type>
        <definition>cy_en_profile_status_t Cy_Profile_DisableCounter</definition>
        <argsstring>(cy_stc_profile_ctr_ptr_t ctrAddr)</argsstring>
        <name>Cy_Profile_DisableCounter</name>
        <param>
          <type><ref kindref="member" refid="group__group__profile__data__structures_1gac954b1f2e2b8fc00b15f89c0b1fe372e">cy_stc_profile_ctr_ptr_t</ref></type>
          <declname>ctrAddr</declname>
        </param>
        <briefdescription>
<para>Disables an assigned counter. </para>        </briefdescription>
        <detaileddescription>
<para><ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref> must have been called for this counter before calling this function.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ctrAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>The handle to the assigned counter, (returned by calling <ref kindref="member" refid="group__group__profile__functions__counter_1ga077b14aae89e02d6e01699e873fe3a9b">Cy_Profile_ConfigureCounter()</ref>).</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />A<sp />profile<sp />counter<sp />assigned<sp />to<sp />position<sp />#0<sp />is<sp />no<sp />longer<sp />needed<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp />and<sp />can<sp />be<sp />disabled.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />List<sp />of<sp />handles<sp />for<sp />allocated<sp />counters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__profile__ctr__t">cy_stc_profile_ctr_ptr_t</ref><sp />cntHandle[PROFILE_PRFL_CNT_NR]<sp />=<sp />{0UL};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disable<sp />the<sp />profile<sp />counter<sp />in<sp />position<sp />#0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga7b44ab102e66cd5a0b243ac67dbd1c3c">Cy_Profile_DisableCounter</ref>(cntHandle[0]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Free<sp />the<sp />profile<sp />counter<sp />in<sp />position<sp />#0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__profile__enums_1gga7d980aa8f4c0159ccc47a973dd543e02a9328da8e423851a200dc18bceea5b54c">CY_PROFILE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__profile__functions__counter_1ga76efcb49377e1bbeffd2eab29d8673ca">Cy_Profile_FreeCounter</ref>(cntHandle[0]))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="332" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_profile.c" bodystart="319" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_profile.h" line="481" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>